$title	QTool Report Program (QR.GMS)

$if not set item   $goto syntax
$if not set domain $goto syntax

$if not set outdir $set outdir output
$if not set xlsfile $set xlsfile %outdir%\pivotreport


$call 'gdxmerge %outdir%\*.gdx id=%item%,q_inputs';

set	q_r(*)	Runs;

$gdxin merged.gdx
$load q_r=Merged_set_1

$if exist "%outdir%\qr.inc" $include "%outdir%\qr.inc"
alias (*,%inputs%);

$if "%domain%"=="" $goto nodomain

$label domain
alias (*,%domain%);
set	header /%inputs%,%domain%,value/;
parameter	pt_item(*,%domain%)		Item to be pivoted;

set		inputs(*,%inputs%)	Correspondence of runs to input assignments;

$load pt_item=%item% inputs=q_inputs
display pt_item;

parameter	p_item;
loop(q_r,	loop(inputs(q_r,%inputs%),
		p_item(%inputs%,%domain%) = pt_item(q_r,%domain%);
));
execute_unload '%outdir%\pivotdata.gdx',p_item=%item%,header;
$goto gdxxrw

$label nodomain
set	header /%inputs%,value/;
parameter	pt_items(*)		Item to be pivoted;
set		inputs(*,%inputs%)	Correspondence of runs to input assignments;

$load pt_items=%item% inputs=q_inputs
display pt_items;

parameter	p_items;
loop(q_r,	loop(inputs(q_r,%inputs%),
		p_items(%inputs%) = pt_items(q_r);
));
execute_unload '%outdir%\pivotdata.gdx',p_items=%item%,header;

$label gdxxrw
$onecho	>%outdir%\gdxxrw.rsp
set=header rng="%item%!a1" values=nodata cdim=1 rdim=0
par=%item% rng="%item%!a2" cdim=0 
$offecho
execute 'gdxxrw i="%outdir%\pivotdata.gdx" o="%xlsfile%.xls" @%outdir%\gdxxrw.rsp';
execute 'del %outdir%\pivotdata.gdx';

$exit


$label syntax
$log
$log	QR.GMS	-- A Q-Tool for Excel Reports
$log
$log	Syntax:
$log
$log	gams qr --item=<parameter> --domain="<set ids>"
$log
$log	where item indicates the parameter to report and
$log	domain indicates the titles to appear in the header.
$log	
$log
$log	For example:
$log
$log	gams qr --item=hev   --domain=""
$log
$log	describes a scalar parameter, or
$log
$log	gams qr --item=quant  --domain="s,item"
$log
$log	describes a report for quant(s,item).

